#include <stdio.h>
#include <stdlib.h>
#include <math.h>


  struct mat{ struct mat *next;
              int row;
              double val; } ;
  struct mat * STNL;

  double ***rgdk,****rpck,****slope_f,****slope_df,*zdf;
  double **cbase,*f_off_set;
  double **prelas,***enecon_f,***cdemak,***rdemak;
  double **damage,*mepm;
  double **rkap,**kapk,*klelas,*enelas,**prod_a,***prod_b,**prod_c;
  int ***jv;
  int ictrl1,ictrl6,ictrl8;
  int JC;
  int N_TIME,N_BLK,N_DEM,N_REN,N_RGRADE;

  struct mat *Memo_list;
  int Memo_count;
  int Size_of_integer=sizeof(int);
  int Size_of_double=sizeof(double);
  int Size_of_integer_pt=sizeof(int *);
  int Size_of_double_pt=sizeof(double *);
  int Size_of_integer_pt2=sizeof(int **);
  int Size_of_double_pt2=sizeof(double **);
  int Size_of_double_pt3=sizeof(double ***);
  int Size_of_struct_mat=sizeof(struct mat);
  int Size_of_struct_mat_pt=sizeof(struct mat *);
  int Size_of_struct_mat_pt_pt=sizeof(struct mat **);

  int dual_decomp_opt(int,int,int,int,int*,int*,struct mat***,struct mat***,
      double**,double*,double**,double**,double**,double*,
      double(*)(int, double *),int);
  double optimize(double(*)(int, double *),int,int,int,int*,int*,int*,int*,
       int*,struct mat**,double*,struct mat**,double*,
       double*,struct mat**,double*,struct mat**,double*,double*,double*,
       double*,double*,double,double,double,double,double);
  double quadratic_pro(int,int,int,int,int*,int*,int*,int*,int,
       struct mat**,double*,struct mat**,double*,
       double,struct mat**,double*,double*,double*,double,double,
       double,double);
  double master_problem(int,double,int,int,int,int,int**,int**,int**,
       int*,struct mat***,struct mat***,struct mat***,struct mat***,
       double**,double**,double**,double*,double*,double*,
       double,double,double,double);

  int simplex(int,int,int *,int *,int *, int *,int,struct mat **,
     double *,struct mat **,double *,double,struct mat **,
                   double *,double *,double,double,double,double);
  int newton(int,int,int *,int *,int *,int *,int, struct mat **,
      double *,struct mat **,double *,double,struct mat **, double *,
                  double *, double *,double,double,double,double);
  int del_artvar(int,int,int,struct mat **,double *,struct mat **,
                         double *, int *, int *, int *,double,double);
  int refine_solution_vec(int,int,struct mat**,struct mat**,struct mat*,
            struct mat**,double);
  int refine_shadow_price(int*,int,int,int,int,struct mat**,struct mat**,
          double*,double*,double);
  int refine_inverse_matrix(int,struct mat**,struct mat**,double);
  int check_fsb(int,int,int *,int *,double *,struct mat **,double *,
      struct mat**,struct mat**,double,double);
  int quad_gene(double(*)(int, double*),int,double*,int,
       struct mat**,double*,double*,int*,double,double*);
  double obj_func(int,double*,struct mat**,double*,double,int*,
       int*,int);
  int invmat(int,struct mat**,double);
  int init_mat(int,struct mat**,struct mat**,double);
  void transpose_mat(struct mat**,struct mat **,int,int);
  void transpose_mat2(struct mat**,struct mat **,int,int);
  struct mat *get_mem(struct mat*,int,double);
  struct mat **add_mat(struct mat**,int,double,double);
  struct mat **put_mat(struct mat**,int,double,double);
  void free_mem(struct mat*);
  void make_null(struct mat**);
  void mat_vec(struct mat**,struct mat**,struct mat*,double);
  void cal_grad(int,int*,double*,double*,struct mat**,double*);
  void cal_grad_vec(int*,double*,struct mat**,struct mat*,double);
  double pivot(int,double,struct mat*,struct mat**,double);
  double vec_vec(double*,struct mat*);
  double vec_vec2(struct mat*, struct mat*);
  double vec_vec3(double*,struct mat*,int*);
  double der_redmax(struct mat**,struct mat*);
  void inter_rep(int,int,double*,double);
  void cal_sp(int,int*,double*,struct mat**,double*);
  void mat_scale(int,int,struct mat**,double*,struct mat**,
                                                   double*,double*,int);
  void vec_add(double*,struct mat*,double);
  void remove_zero(struct mat**,double);
  int del_nonl_var(int,int,int,int**,int**,int**,
       struct mat***,struct mat***,double**,double,double);
  void norm_v(int,double *,double *);

  int *iarr1(int);
  int **iarr2(int,int);
  int ***iarr3(int,int,int);
  double *darr1(int);
  double **darr2(int,int);
  double ***darr3(int,int,int);
  double ****darr4(int,int,int,int);
  struct mat **marr1(int);
  struct mat ***marr2(int,int);
  int mod_cholesky_decomp(int,struct mat**,struct mat**,double*,double);

  int read_pp(int,double *);
  void output(int,int,int,int,int,int,int,
            double**,double**,double**,double*,double*);
  double eval(int,double *);
  void read_problem_file();
  void write_sp(int,struct mat***,double**,double*);

  int main()
{
  struct mat ***a,***t0,***t1;
  double **x,**g,**sd,*p,**b,*ev;
  int i,n,k,nc;
  int LR,IR,KE,KEL,IINTER;
  int *islack,*kslack;
  FILE *fp;

  STNL=(struct mat *) malloc(sizeof(struct mat));
  Memo_list=STNL;
  Memo_count=0;

  read_problem_file(&LR,&IR,&JC,&KEL,&N_BLK,&KE,&IINTER,
	                  &a,&t0,&t1,&b,&cbase,&ev,&islack,&kslack);

  g=darr2(LR,JC+2*IR);
  x=darr2(LR,JC+2*IR);
  sd=darr2(LR,IR);
  p=darr1(KE);

  fp=fopen("cvt.tmp","w");
  fclose(fp);

  if(ictrl6==0) {
    read_pp(KE,p);
    nc=dual_decomp_opt(LR,IR,JC,KE,islack,kslack,a,t0,b,ev,x,g,sd,p,
                                                       eval,10*KE);
  }
  else {

/* Approximation Mode */
    for(k=0;k<KE;k++) p[k]=0.;
    read_pp(KE,p);
    nc=dual_decomp_opt(LR,IR,JC,KE,islack,kslack,a,t1,b,ev,x,g,sd,p,
                                                      eval,KE*3);
    for(k=0;k<N_BLK;k++) {
      for(i=0;i<IINTER;i++)
        for(n=0;n<LR;n++) p[n+LR*i+KEL*k]=p[LR*i+KEL*k];
    }
    nc=dual_decomp_opt(LR,IR,JC,KE,islack,kslack,a,t0,b,ev,x,g,sd,p,
                                                       eval,10*KE);
  }

  printf(" Global optimization has been finished.\n");

  output(nc,LR,IR,JC,KE,KEL,N_BLK,x,g,sd,p,zdf);

  if(ictrl1==0) write_sp(LR,a,sd,zdf);

  return(0);
}


  double eval(n,w)
  int n;
  double *w;
{ int i,k,j0;
  double f,v,u,ek,rk,cp,x0;

  f=f_off_set[n];
  for(i=0;i<JC;i++) f+=cbase[n][i]*w[i];

  for(k=0;k<N_BLK;k++) {
    for(i=0;i<2;i++) {
      u=0.;
      v=rgdk[n][i][0];
      j0=0;
      while(v<w[jv[0][i][k]]&& j0<N_RGRADE-1) {
        ++j0;
        u=v;
        v+=rgdk[n][i][j0];
      }
      f+=slope_f[n][i][j0][k];
      v=w[jv[0][i][k]]-u;
      f+=v*(slope_df[n][i][j0][k]*v+rpck[n][i][j0][k]);
    }
  }


  if(ictrl1==1) {
    if(ictrl8==0) {
      for(k=0;k<N_BLK;k++) {
        for(i=0;i<N_DEM;i++) {

		  v=prelas[n][i]+1.;
          x0=(rdemak[n][i][k]+w[jv[1][i][k]])/cdemak[n][i][k];
          f+=enecon_f[n][i][k]*(1.-pow(x0,v));
       }
      }
    }
    else {

	  rk=1./klelas[n];

	  ek=klelas[n]/enelas[n];
      for(k=0;k<N_BLK;k++) {

		cp=prod_c[n][k];
        v=0.;
        for(i=0;i<N_DEM;i++) {
          x0=(rdemak[n][i][k]+w[jv[1][i][k]])/cdemak[n][i][k];
          v+=prod_b[n][i][k]*pow(x0,enelas[n]);
        }

		x0=(w[jv[2][1][k]]+rkap[n][k])/kapk[n][k];

        u=pow(v,ek)+prod_a[n][k]*pow(x0,cp);

        f-=pow(u,rk);

      }

    }
  }
  for(k=0;k<N_BLK;k++)
    f+=damage[n][k]*pow(w[jv[2][0][k]],mepm[n]);

  return(f);
}


  int dual_decomp_opt(lr,ir,jc,ke,isl,ksl,a,t,b,ev,x,g,sd,p,f,ncount)
  double (*f)(int,double *);
  int lr,ir,jc,ke,*isl,*ksl,ncount;
  struct mat ***a,***t;
  double *p,**x,**g,**sd,**b,*ev;
{ 
  int n,i,k,nc,iflag,ncm;
  double h0,h1,dh,v,g_zero,dhi;
  struct mat *pt,*pt0;
  FILE *fp;
  struct mat ***h,***ddxp;
  double **cp,*xbias,**c,**ps,**qs;
  double *dp,*p_temp,abs_dp;
  int **ib,**jn,**ln,**nl,*xndim;
  int jtt,mode;
  double es0,es1,es2,es3,es4,es5;

  Memo_list=STNL;
  Memo_count=0;

  es1=1.e-10;      /* Criterion of Zero in Matrix Operation */
  es2=1.e-3;       /* Criterion for Feasibility */
  es3=1.e-5;       /* Minimum Absolute Value of Pivot Axis */
  es4=1.e-6;       /* Criterion for Convergence in opt */
  es0=1.e-5;       /* Criterion for Optimality */
  es5=es0;         /* Criterion of Cycling in Master Problem */

  jtt=jc+2*ir;

  c=darr2(lr,jtt);
  cp=darr2(lr,jtt);
  ps=darr2(lr,jc);
  qs=darr2(lr,ir);
  ib=iarr2(lr,ir);
  jn=iarr2(lr,jtt);
  ln=iarr2(lr,jtt);
  nl=iarr2(lr,jc);
  h=marr2(lr,ir);
  ddxp=marr2(lr,8*N_BLK);


  xbias=darr1(lr);
  dp=darr1(ke);
  p_temp=darr1(ke);
  xndim=iarr1(lr);

  h1=0.;
  for(k=0;k<ke;k++) h1-=p[k]*ev[k];
  printf("\n Initialization...\n\n");
  for(n=0;n<lr;n++) {
    printf(" Region %2d  ",n+1);
    mat_scale(jc,ir,a[n],b[n],t[n],ps[n],qs[n],5);
    for(i=0;i<ir;i++) {
      if(isl[i]==1) put_mat(&a[n][jc+i],i,-1.0,0.);
      c[n][jc+i]=0.;
      cp[n][jc+i]=0.;
      ln[n][jc+i]=-1;
    }

	for(i=0;i<jc;i++) x[n][i]=0.;

    for(i=0;i<jc;i++) {

      c[n][i]=ps[n][i]*cbase[n][i];

      ln[n][i]=-1;

	}

    xndim[n]=quad_gene(f,n,x[n],jc,ddxp[n],c[n],xbias,nl[n],2.,ps[n]);

    for(i=0;i<xndim[n];i++)	ln[n][nl[n][i]]=i;

	printf(" %d\n",xndim[n]);
    for(i=0;i<jc;i++) cp[n][i]=c[n][i]+vec_vec(p,t[n][i]);
    h1+=quadratic_pro(2,ir,jc,jc,ib[n],jn[n],ln[n],nl[n],
        xndim[n],a[n],b[n],
        ddxp[n],cp[n],xbias[n],h[n],x[n],sd[n],g[n],es0,es1,es2,es3);
  }

  if(h1<0.) {
    printf("\n Reset pp.dat\n\n");
    for(k=0;k<ke;k++) p[k]=0.;
    for(n=0;n<lr;n++) 
      for(i=0;i<jc;i++) cp[n][i]=c[n][i]+vec_vec(p,t[n][i]);
    h1=0.;
  }

  printf("\n Optimization...\n\n");

  h1=0.;
  for(k=0;k<ke;k++) h1-=p[k]*ev[k];
  for(n=0;n<lr;n++) {
    h1+=optimize(f,n,ir,jc,ib[n],jn[n],ln[n],nl[n],
        xndim,a[n],b[n],ddxp[n],cp[n],xbias,
        h[n],x[n],t[n],c[n],p,sd[n],g[n],ps[n],es0,es1,es2,es3,es4);
  }

  nc=0;
  for(k=0;k<ke;k++) dp[k]=0.;
  dh=1.e40;
  dhi=0.;

  do {

    for(k=0;k<ke;k++) p_temp[k]=p[k];
    h0=h1;  
    norm_v(ke,&abs_dp,dp);      
    ncm=0;
    v=abs_dp;
    do {
      if(h1<=h0) {
	for(k=0;k<ke;k++) p[k]=p_temp[k]+v*dp[k];
        for(n=0;n<lr;n++) 
          for(i=0;i<jc;i++) cp[n][i]=c[n][i]+vec_vec(p,t[n][i]);
      }
      h1=0.;
      for(k=0;k<ke;k++) h1-=p[k]*ev[k];
      for(n=0;n<lr;n++) {
        h1+=quadratic_pro(0,ir,jc,jc,ib[n],jn[n],ln[n],nl[n],
          xndim[n],a[n],b[n],
          ddxp[n],cp[n],xbias[n],h[n],x[n],sd[n],g[n],es0,es1,es2,es3);
      }
      ncm++;
      v*=0.7;
    }while(h1<h0&&v>es0);

    if(h1<h0) {
      for(k=0;k<ke;k++) p[k]=p_temp[k];
      for(n=0;n<lr;n++) 
        for(i=0;i<jc;i++) cp[n][i]=c[n][i]+vec_vec(p,t[n][i]);
    }
    dhi+=h1-h0;
    if(dhi>1.e5) {
      dhi=0.;
      h1=0.;
      for(k=0;k<ke;k++) h1-=p[k]*ev[k];
      for(n=0;n<lr;n++) {
        h1+=optimize(f,n,ir,jc,ib[n],jn[n],ln[n],nl[n],
            xndim,a[n],b[n],ddxp[n],cp[n],xbias,
            h[n],x[n],t[n],c[n],p,sd[n],g[n],ps[n],es0,es1,es2,es3,es4);
      }
    }

    g_zero=0.001;
    if(dh<=1.) mode=1;
    else  mode=0;

    printf(" %4d %2d  H=%15.5f %d\n",nc,ncm,h1,mode);

    dh=master_problem(mode,g_zero,lr,ir,jc,ke,ib,jn,ln,ksl,
                              a,t,ddxp,h,x,g,b,ev,p,dp,es0,es1,es2,es3);

    printf("         dH=%15.5f\n",dh);

    inter_rep(ke,nc,p,h1);

    nc++;

  }while(nc<ncount&&dh!=0.);

  for(n=0;n<lr;n++) {
    for(i=0;i<jc;i++) {
      pt=a[n][i];
      while(pt!=STNL) {
        (pt->val)/=(ps[n][i]*qs[n][pt->row]);
        pt=pt->next;
      }
      pt=t[n][i];
      while(pt!=STNL) {
        (pt->val)/=ps[n][i];
        pt=pt->next;
      }
      x[n][i]*=ps[n][i];
      g[n][i]/=ps[n][i];
    }
    for(i=0;i<ir;i++) {
      b[n][i]/=qs[n][i];
      sd[n][i]*=qs[n][i];
    }
  }

  for(n=0;n<lr;n++) {
    free(c[n]);
    free(cp[n]);
    free(ps[n]);
    free(qs[n]);
    free(ib[n]);
    free(jn[n]);
    free(ln[n]);
    free(nl[n]);
    for(i=jc;i<jc+2*ir;i++) make_null(a[n]+i);
    for(i=0;i<ir;i++) make_null(h[n]+i);
    for(i=0;i<xndim[n];i++) make_null(ddxp[n]+i);
    free(h[n]);
    free(ddxp[n]);
  }
  free(ps);  free(qs);  free(cp);  free(ib);
  free(jn);  free(ln);  free(nl);  free(c);
  free(h);  free(ddxp);
  free(p_temp);
  free(dp);  free(xndim);
  pt=Memo_list;
  while(pt!=STNL) {
    pt0=pt->next;
    free(pt);
    pt=pt0;
    Memo_count--;
  }
  if(Memo_count!=0) {
    printf(" Memo_count= %d \n",Memo_count);
    exit(0);
  }
  return(nc);
}



  double master_problem(mode,g_zero,lr,ir,jc,ke,ib,jn,ln,ksl,a,t,
                                  ddxp,h,x,g,b,ev,p,dp,es0,es1,es2,es3)
  int mode,lr,ir,jc,ke,*ksl,**ib,**jn,**ln;
  struct mat ***a,***h,***ddxp,***t;
  double *p,**x,**g,**b,*ev,*dp,es0,es1,es2,es3,g_zero;
{ int i,k,n,nd,i0,k0,n0,idim,my,kem,mym,kdim,iflag,yndim;
  int *xndim,*kd,*yib,*yjn,*yln,*ynl;
  double dh,yct,*y,*yb,*dy,*yg,*ysd,**x_temp,*b_temp,ybias,v;
  struct mat *pt,**ppt,**atmpn,**atmpn_row,**ab,**tb,*atm,**hpt;
  struct mat **tm,**ddyp,**m_row;

  xndim=iarr1(lr);
  yndim=0;
  for(n=0;n<lr;n++) {
    xndim[n]=0;
    for(i=0;i<jc+ir;i++) if(ln[n][i]!=-1) xndim[n]++;
    yndim+=xndim[n];
  }

  my=lr*jc;
  kem=lr*ir+ke;
  mym=my+2*kem;

  tm=marr1(mym);
  atmpn=marr1(yndim);
  atmpn_row=marr1(yndim);
  ab=marr1(ir);
  tb=marr1(ir);
  m_row=marr1(kem);
  hpt=marr1(kem);
  y=darr1(mym);
  yb=darr1(kem);
  yg=darr1(mym);
  dy=darr1(mym);
  ysd=darr1(kem);
  yib=iarr1(kem);
  yjn=iarr1(mym);
  yln=iarr1(mym);
  ynl=iarr1(yndim);
  kd=iarr1(kem);
  ddyp=marr1(yndim);

  atm=STNL;

  del_nonl_var(lr,ir,jc,ib,jn,ln,a,h,g,es0,es1);

  nd=0;
  for(n=0;n<lr;n++) {
    for(i=0;i<ir;i++) {ab[i]=a[n][ib[n][i]]; tb[i]=t[n][ib[n][i]];}
    init_mat(ir,ab,h[n],es1);
    /*    refine_inverse_matrix(ir,ab,h[n],es1);*/
    idim=0;
    for(i=0;i<jc;i++){
      i0=jn[n][i];
      mat_vec(&atm,h[n],a[n][i0],es1);
      k0=n*jc+i;
      mat_vec(tm+k0,tb,atm,es1);
      ppt=tm+k0;
      pt=t[n][i0];
      while(pt!=STNL) {
        ppt=add_mat(ppt,pt->row,-(pt->val),es1);
        pt=pt->next;
      }
      if(ln[n][i0]!=-1) {
        make_null(atmpn+idim);
        put_mat(atmpn+idim,ln[n][i0],-1.,0.);
        pt=atm;
        while(pt!=STNL) {
          if((n0=ln[n][ib[n][pt->row]])!=-1)
            put_mat(atmpn+idim,n0,pt->val,0.);
          pt=pt->next;
	}
        dy[k0]=g[n][i0];
        y[k0]=x[n][i0];
        yln[k0]=nd+idim;
        ynl[nd+idim]=k0;
	idim++;
      }
      else {
        y[k0]=0.;
        yln[k0]=-1;
        dy[k0]=g[n][i0];
      }

      pt=atm;
      ppt=tm+k0;
      n0=n*ir+ke;
      if(((yln[k0]==-1||mode)&&(dy[k0]<g_zero))) {
        while(pt!=STNL) {
          ppt=put_mat(ppt,(pt->row)+n0,pt->val,0.);
          pt=pt->next;
        }
      }
      else {
	/*
        while(pt!=STNL) {
          if(x[n][ib[n][pt->row]]<=es2*10.)
            ppt=put_mat(ppt,(pt->row)+n0,pt->val,0.);
          pt=pt->next;
        }
	*/
      }
      if(dy[k0]<0.) dy[k0]=0.;
    }
    for(i=0;i<ir;i++) {
      if(x[n][ib[n][i]]<0.) x[n][ib[n][i]]=0.;
      yb[ke+n*ir+i]=x[n][ib[n][i]];
    }
    transpose_mat(atmpn,atmpn_row,idim,xndim[n]);
    for(i=0;i<idim;i++) {
      mat_vec(&atm,ddxp[n],atmpn[i],0.);
      mat_vec(atmpn+i,atmpn_row,atm,0.);
      make_null(ddyp+nd+i);
      pt=atmpn[i];
      ppt=ddyp+nd+i;
      while(pt!=STNL) {
        ppt=put_mat(ppt,nd+(pt->row),pt->val,0.);
        pt=pt->next;
      }
      make_null(atmpn+i);
    }
    for(i=0;i<xndim[n];i++) make_null(atmpn_row+i);
    nd+=idim;
  }
  make_null(&atm);

  for(i=0;i<nd;i++) {
    pt=ddyp[i];
    while(pt!=STNL) {
      dy[ynl[pt->row]]-=y[ynl[i]]*(pt->val);
      pt=pt->next;
    }
  }
  ybias=0.;
  for(i=0;i<nd;i++) {
    yct=dy[ynl[i]];
    pt=ddyp[i];
    while(pt!=STNL) {
      yct+=y[ynl[pt->row]]*(pt->val)*0.5;
      pt=pt->next;
    }
    ybias-=y[ynl[i]]*yct;
  }


  /*******************************************************/


  for(i=0;i<ke;i++) yb[i]=-ev[i];
  for(n=0;n<lr;n++) for(i=0;i<jc;i++) vec_add(yb,t[n][i],x[n][i]);

  transpose_mat2(tm,m_row,my,kem);
  kdim=0;
  for(i=0;i<kem;i++) {
    if(m_row[i]!=STNL) {
      m_row[kdim]=m_row[i];
      if(i!=kdim) m_row[i]=STNL;
      yb[kdim]=yb[i];
      kd[kdim]=i;
      kdim++;
    } 
  }
  transpose_mat2(m_row,tm,kdim,my);

  for(i=0;i<kdim;i++) {
    make_null(tm+my+i);
    y[my+i]=0.;
    dy[my+i]=0.;
    yln[my+i]=-1;
    if(kd[i]<ke) {
      if(ksl[kd[i]]==1) {
        dy[my+i]=p[kd[i]];
        tm[my+i]=get_mem(STNL,i,-1.);
      }
    }
    else tm[my+i]=get_mem(STNL,i,1.);
  }
  for(i=0;i<my;i++) vec_add(yb,tm[i],y[i]);


  dh=quadratic_pro(1,kdim,my,my,yib,yjn,yln,ynl,nd,
                 tm,yb,ddyp,dy,ybias,hpt,y,ysd,yg,es0,es1,es2,es3);

  for(i=0;i<ke;i++) dp[i]=0.;
  for(i=0;i<kdim;i++) if(kd[i]<ke) dp[kd[i]]=ysd[i];


/********* Check Feasibilty **********/  
  if(dh<1.&&mode) {
    x_temp=darr2(lr,jc+ir);
    b_temp=darr1(ir);
    for(n=0;n<lr;n++) for(i=0;i<jc+ir;i++) x_temp[n][i]=x[n][i];
    for(k=0;k<kdim;k++) {
      if(kd[k]>=ke) {
        n=(kd[k]-ke)/ir; i=(kd[k]-ke)%ir;
        x[n][ib[n][i]]=y[k+lr*jc];
      }
    }
    iflag=0;
    for(i=0;i<ke;i++) yb[i]=-ev[i];
    for(n=0;n<lr;n++) {
      for(i=0;i<jc;i++) x[n][jn[n][i]]=y[n*jc+i];
      for(i=0;i<ir;i++) b_temp[i]=b[n][i];
      for(i=0;i<jc+ir;i++) 
        if(x[n][i]>0.) vec_add(b_temp,a[n][i],-x[n][i]);
        else x[n][i]=0.;
      for(i=0;i<ir;i++) if(fabs(b_temp[i])>es2) iflag=1;
      for(i=0;i<jc;i++) vec_add(yb,t[n][i],x[n][i]);
    }
    for(i=0;i<ke;i++)
      if((ksl[i]==0||yb[i]>0.)&&fabs(yb[i])>es2) iflag=1;

    if(iflag) {
      for(n=0;n<lr;n++) for(i=0;i<jc+ir;i++) x[n][i]=x_temp[n][i];
      dh=es0;
    }
    else dh=0.;
    for(n=0;n<lr;n++) free(x_temp[n]);
    free(x_temp);
    free(b_temp);
  }

/******* Free memories ***********/

  for(i=0;i<kem;i++) make_null(hpt+i);  
  for(i=0;i<yndim;i++) make_null(ddyp+i);  
  for(i=0;i<mym;i++) make_null(tm+i);
  free(hpt);
  free(ddyp);
  free(tm);
  free(atmpn);
  free(atmpn_row);
  free(ab);
  free(tb);
  free(m_row); 
  free(xndim);
  free(y);  free(yb);  free(yg);  free(dy);  free(ysd);
  free(yib); free(yjn); free(yln); free(ynl); free(kd);
  return(dh);
}



  double optimize(f,n,ir,jc,ib,jn,ln,nd,ndim,
          a,b,ddxp,cp,me,h,x,t,c,p,sp,g,ps,es0,es1,es2,es3,es4)
  double (*f)(int,double *);
  int n,ir,jc,*ndim,*ib,*jn,*ln,*nd;
  struct mat **a,**h,**ddxp,**t;
  double *b,*cp,*c,*p,*x,*g,*sp,*me,*ps,es0,es1,es2,es3,es4;
{ double dh,u0,u1,*x0,*x1,*x2;
  int i,ip,iq;
  struct mat *pt,**mt;
  x0=darr1(jc);
  x1=darr1(jc);
  x2=darr1(jc);

  mt=marr1(ir);
  for(i=0;i<ir;i++) mt[i]=a[ib[i]];
  refine_inverse_matrix(ir,mt,h,es1);
  free(mt);

  ip=0;
  do {
    for(i=0;i<jc;i++) x2[i]=x[i]*ps[i];
    u0=(*f)(n,x2);
    for(i=0;i<jc;i++) {
      pt=t[i];
      if(pt!=STNL) {
        while(pt!=STNL){
          u0+=x[i]*p[pt->row]*(pt->val);
          pt=pt->next;
	}
      }
    }


    for(i=0;i<jc;i++) x0[i]=x[i];
    dh=quadratic_pro(0,ir,jc,jc,ib,jn,ln,nd,ndim[n],a,b,
                       ddxp,cp,me[n],h,x,sp,g,es0,es1,es2,es3);
    for(i=0;i<jc;i++) x1[i]=x[i];
    iq=0;

    do {

      for(i=0;i<jc;i++) x2[i]=x1[i]*ps[i];
      u1=(*f)(n,x2);
      for(i=0;i<jc;i++) {
        pt=t[i];
        if(pt!=STNL) {
          while(pt!=STNL){
            u1+=x1[i]*p[pt->row]*(pt->val);
            pt=pt->next;
	  }
	}
      }
      if(u1>u0)
        for(i=0;i<jc;i++) x1[i]=(x1[i]+x0[i])*0.5;
      iq++;
    }while(u1>u0&&iq<20);


    quad_gene(f,n,x1,jc,ddxp,c,me,nd,2.,ps);
    for(i=0;i<jc;i++) cp[i]=c[i]+vec_vec(p,t[i]);
    ip++;
  } while(fabs((u0-dh)/u0)>es4&&ip<10);
  free(x0);
  free(x1);
  free(x2);
  return(dh);
}


  double quadratic_pro(mode,ir,jc,jcb,ib,jn,ln,nd,ndim,
                        a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3)
  int mode,ir,jc,jcb,ndim,*ib,*jn,*ln,*nd;
  struct mat **a,**h,**ddxp;
  double *b,*cp,*w,*wg,*sp,me,es0,es1,es2,es3;
{ int flag1,flag2,flag3,flag4,count,i,jtmp,jdim,j0,jct,nc;
  double *bt,v;
  struct mat *pt,**mt;
  FILE *fp;

  mt=marr1(ir);

  jct=jc+ir;
  jtmp=jc;
  if(mode>0) {
    bt=darr1(ir);
    for(i=0;i<ir;i++) bt[i]=b[i];
    if(mode==2) for(i=0;i<jct;i++) w[i]=0.;
    else {
      for(i=0;i<jct;i++){
        if(w[i]>0.) vec_add(bt,a[i],-w[i]);
        else w[i]=0.;
      }
    }
    for(i=0;i<jc;i++) jn[i]=i;
    for(i=0;i<ir;i++) {
      make_null(h+i);
      pt=a[jc+i];
      if(pt!=STNL&&(pt->val)*bt[i]>=0.&&pt->row==i&&pt->next==STNL){
        ib[i]=jc+i;
        w[ib[i]]=bt[i]/(pt->val);
      }
      else {
	jn[jtmp]=jc+i;
	j0=jtmp+ir;
        ib[i]=j0;
        if(bt[i]>0.) v=1.0;
        else v=-1.0;
        make_null(a+j0);
        a[j0]=get_mem(STNL,i,v); 
        w[j0]=v*bt[i];
        ln[j0]=-1;
        cp[j0]=10.;
	jtmp++;
      }
    }
    for(i=0;i<ir;i++) mt[i]=a[ib[i]];
    if(init_mat(ir,mt,h,es1)){
      fp=fopen("cvt.tmp","a");
      fprintf(fp," Failure in the begining of quadratic_pro!!\n");
      fclose(fp);
      exit(0);
    }
    free(bt);
  }

  count=0;

  do {
    flag3=0;
    flag2=-1;
    flag1=simplex(ir,jtmp,ib,jn,ln,nd,ndim,
                          a,b,ddxp,cp,me,h,w,sp,es0,es1,es2,es3);
    if(flag1==-3) flag3=1;
    else if(flag1>=0) {
      fp=fopen("cvt.tmp","a");
      fprintf(fp," There is no optimal solution!!\n");
      fclose(fp);
      printf(" There is no optimal solution!! \n");
      exit(0);
    }
    else {
      flag2=newton(ir,jtmp,ib,jn,ln,nd,ndim,
                              a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3);
      if(flag2==-3) flag3=1;
    }

  } while(flag3==0 && (flag1!=-1||flag2!=-1) && ++count<2000);

  for(i=0;i<ir;i++) mt[i]=a[ib[i]];
  if(flag3!=1&&check_fsb(jtmp,ir,ib,jn,w,a,b,h,mt,es1,es2)) flag3=1;
  free(mt);

  if(flag3==1){
    if(es3>1.){
      for(i=0;i<ir;i++) sp[i]=0.;
      for(i=0;i<jct;i++) w[i]=0.;
      v=0.;
    }
    else {
      fp=fopen("cvt.tmp","a");
      fprintf(fp," ESP3= %f\n",es3);
      fclose(fp);
      es3*=10.;
      v=quadratic_pro(2,ir,jcb,jcb,ib,jn,ln,nd,ndim,
                       a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3);
    }
  }
  else {
    if(mode>0) {
      v=0.;
      for(i=jct;i<jtmp+ir;i++) v+=w[i];
      nc=1;
      while(v>es2&&nc<100) {
        for(i=jct;i<jtmp+ir;i++) cp[i]+=10.*nc*nc;
        for(i=0;i<jtmp;i++) 
          if(jn[i]>=jct&&jn[i]<jtmp+ir) cp[jn[i]]=1.e20;
        quadratic_pro(0,ir,jtmp,jcb,ib,jn,ln,nd,ndim,
                       a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3);
        v=0.;
        for(i=jct;i<jtmp+ir;i++) v+=w[i];
        nc++;
      }
      if(mode==2) {
        for(i=jct;i<jtmp+ir;i++) cp[i]*=1.e5;
        quadratic_pro(0,ir,jtmp,jcb,ib,jn,ln,nd,ndim,
                      a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3);
        jdim=0;
        for(i=0;i<jtmp;i++) if(jn[i]<jct) jn[jdim++]=jn[i];
        flag4=del_artvar(ir,jct,jdim,a,b,h,w,ib,jn,ln,es1,es2);
        if(flag4) {
          quadratic_pro(0,ir,jc,jcb,ib,jn,ln,nd,ndim,
                       a,b,ddxp,cp,me,h,w,sp,wg,es0,es1,es2,es3);
	}
      }
    }
    v=obj_func(jct,w,ddxp,cp,me,ln,nd,ndim);
  }
  return(v);
}


  int simplex(ir,jc,ib,jn,ln,nd,ndim,a,b,
                                 ddxp,cp,bias,h,w,sp,es0,es1,es2,es3)
  int ir,jc,*ib,*jn,*ln,*nd,ndim; 
  double bias,es0,es1,es2,es3,*b,*cp,*w,*sp;
  struct mat **a,**ddxp,**h;
{ int i,i0,j0,k0,n0,m0,i1,j1,flag,idc,nbs,ncmax;
  int ncs,flag_return,flag_recal,flag_init,flag_dev,flag_non,flag_deg;
  double redmax,maxstep,step,v,maxval,axis,max_num,mini_maxstep,maxval2,dev;
  struct mat *pt,*atm,*atmn,*pt0,*shp,**mt,**a_row;
  double *red,*vcan,*cnl,*ucan;
  int *ican,*lcan,*kcan;
  FILE *fp;

  mt=marr1(ir);
  for(i=0;i<ir;i++) mt[i]=a[ib[i]];

  red=darr1(jc+ir);
  vcan=darr1(jc+ir);
  ucan=darr1(2*ir);
  cnl=darr1(jc+ir);
  ican=iarr1(jc+ir);
  kcan=iarr1(ndim);
  lcan=iarr1(ndim);
  a_row=marr1(ir);
  transpose_mat(a,a_row,ir+jc,ir);

  atm=STNL;
  atmn=STNL;
  shp=STNL;
  ncmax=4;
  max_num=1.0e20;

  for(i=0;i<ir;i++) ucan[ir+i]=pow((double)(i+1),0.7);

  for(i=0;i<ir+jc;i++) cnl[i]=cp[i];
  cal_grad(ndim,nd,w,cnl,ddxp,cp);
  cal_sp(ir,ib,cnl,h,sp);
  refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
  for(i=0;i<jc;i++) {
    k0=jn[i];
    if(w[k0]<=0.) red[k0]=vec_vec(sp,a[k0])-cnl[k0];
  }
  for(i=0;i<jc;i++)
    if((n0=ln[jn[i]])!=-1) { kcan[n0]=0; lcan[n0]=jn[i]; }
  for(i=0;i<ir;i++)
    if((n0=ln[ib[i]])!=-1) { kcan[n0]=1; lcan[n0]=i; }

  ncs=0;
  flag_return=-1;
  flag_init=1;
  flag_deg=0;
  maxval=0.;

  do {
    ncs++;
    redmax=es0;
    idc=0;
    j0=-1;
    flag=0;
    do{
      for(i=0;i<jc;i++) {
        k0=jn[i];
        v=red[k0];
        if(w[k0]<=0.&&v>es0){
          if(v>redmax) { redmax=v; j0=i; }
          ican[idc]=i;
          vcan[idc]=v;
          idc++;
        }
      }
      if(idc==0&&flag==0) {
        cal_grad(ndim,nd,w,cnl,ddxp,cp);
        cal_sp(ir,ib,cnl,h,sp);
        refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
      }
      flag++;
    }while(idc==0&&flag<2);

    if(idc>0) {
      flag_return=-2;
      maxval=0.;
      if(flag_init) {

        do{
          redmax*=0.1;
          for(i=0;i<idc;i++) {
            if(vcan[i]>=redmax) {
              mat_vec(&atm,h,a[jn[ican[i]]],es1);
              pt=atm;
              maxstep=max_num;
              while(pt!=STNL&&maxstep>0.) {
                if((v=pt->val)>0.) {
                  step=w[ib[pt->row]]/v;
                  if(step<maxstep) maxstep=step;
		}
                pt=pt->next;
	      }
              if(maxval<(v=maxstep*vcan[i])) {
                maxval=v;
                j0=ican[i];
	      }
              vcan[i]=0.;
	    }
	  }
        }while (redmax>es0&&maxval<es2*redmax*100.);
      }
      else {
        j0=-1;
        j1=-1;
        maxval2=0.;
        for(i=0;i<idc;i++) {
          mat_vec(&atm,h,a[jn[ican[i]]],es1);
          pt=atm;
          maxstep=max_num;
          axis=0;
          while(pt!=STNL&&maxstep>0.) {
            if((v=pt->val)>0.) {
              step=w[ib[pt->row]]/v;
              if(step<maxstep) {
                maxstep=step;
                axis=v;
	      }
	    }
            pt=pt->next;
	  }
          if(j1==-1&&maxval<axis&&maxstep>0.) {
            maxval=axis;
            j0=ican[i];
	  }
          if(axis>es3&&maxval2<vcan[i]*maxstep) {
            maxval2=vcan[i]*maxstep;
            j1=ican[i];
	  }
	}
        if(j1!=-1) j0=j1;
        if(j0==-1) {
	  for(i=0;i<ir;i++) 
            if(w[ib[i]]<=0.&&ucan[i]<=0.) ucan[i]=ucan[ir+i];
          for(i=0;i<idc;i++) {
            mat_vec(&atm,h,a[jn[ican[i]]],es1);
            pt=atm;
            maxstep=max_num;
            axis=0;
            while(pt!=STNL) {
              if((v=pt->val)>0.&&w[ib[pt->row]]<=0.){
                step=ucan[pt->row]/v;
                if(step<maxstep) {
                  maxstep=step;
                  axis=v;
		}
	      }
              pt=pt->next;
	    }
            if(j1==-1&&maxval<axis) {
              maxval=axis;
              j0=ican[i];
	    }
            if(axis>es3&&maxval2<vcan[i]) {
              maxval2=vcan[i];
              j1=ican[i];
            }
            if(j1!=-1) j0=j1;
	  }
	}
      }
    
      k0=jn[j0];
      mat_vec(&atm,h,a[k0],es1);
      m0=refine_solution_vec(0,ncmax,mt,h,a[k0],&atm,es1);
      remove_zero(&atm,es1*10.);
      redmax=vec_vec3(cnl,atm,ib)-cnl[k0];

      i0=-1;
      pt=atm;
      maxstep=max_num;
      axis=0.;
      while(pt!=STNL&&maxstep>0.) {
        if((v=pt->val)>0.) {
          step=w[ib[pt->row]]/v;
          if(step<maxstep) {
            maxstep=step;
            i0=pt->row;
            axis=v;
	  }
	}
        pt=pt->next;
      }
      if(maxstep<0.) maxstep=0.;
      flag_dev=0;
      flag_non=0;

      if(maxstep>0.) {
        i1=i0;
	flag_deg=0;
        make_null(&atmn);
        pt=atm;
        while(pt!=STNL) {
          if((n0=ln[ib[pt->row]])!=-1)
            put_mat(&atmn,n0,-(pt->val),es1);
          pt=pt->next;
	}
        if((n0=ln[k0])!=-1) put_mat(&atmn,n0,1.,0.);
        dev=der_redmax(ddxp,atmn);
        if(dev>0.) {
          flag_non=1;
          step=redmax/dev;
          if(i0==-1||step<maxstep) {
            maxstep=step;
            flag_dev=1;
	  }
          if(ln[k0]==-1) {
            if(flag_dev) {axis=0.; i0=-1;}
            pt=atm;
            while(pt!=STNL) {
              if(ln[ib[pt->row]]!=-1 && fabs(pt->val)>axis) {
                i0=pt->row;
                axis=fabs(pt->val);
	      }
              pt=pt->next;
	    }
	  }
          else {i0=-2; axis=1.;}
	}
      }
      else {
	if(flag_deg==0)
	  for(i=0;i<ir;i++) if(w[ib[i]]<=0.) ucan[i]=ucan[ir+i];
	maxstep=max_num;
	i0=-1;
        pt=atm;
        while(pt!=STNL) {
          if((v=pt->val)>0.&&w[ib[pt->row]]<=0.){
            step=ucan[pt->row]/v;
            if(step<maxstep) {
              maxstep=step;
              i0=pt->row;
              axis=v;
	    }
	  }
          pt=pt->next;
	}
	flag_deg=1;
        i1=i0;
      }

      flag_recal=0;
      if(flag_init&&(i0==-1||redmax<0.||(axis>1./es3)||(axis<es3)||m0==ncmax))
        flag_recal=1;
      flag_init=1;
      if(flag_recal) {
        if(refine_inverse_matrix(ir,mt,h,es1)
        || check_fsb(jc,ir,ib,jn,w,a,b,h,mt,es1,es2)) flag_return=-3;
        else {
          cal_grad(ndim,nd,w,cnl,ddxp,cp);
          cal_sp(ir,ib,cnl,h,sp);
          refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
          for(i=0;i<jc;i++) {
            k0=jn[i];
            if(w[k0]<=0.) red[k0]=vec_vec(sp,a[k0])-cnl[k0];
          }
          flag_init=0;
        }
      }
      else if(j0!=-1&&i0!=-1) {
	red[k0]=redmax;
        if(flag_deg==0) {
          pt=atm;
          while(pt!=STNL) {
            w[ib[pt->row]]-=(pt->val)*maxstep;
            if(w[ib[pt->row]]<1.e-15) w[ib[pt->row]]=0.;
            pt=pt->next;
          }
          w[k0]=maxstep;
        }
	else {
          pt=atm;
          while(pt!=STNL) {
            ucan[pt->row]-=(pt->val)*maxstep;
            pt=pt->next;
          }
          ucan[i0]=maxstep;
	}

        if(flag_dev==0&&i1>=0) w[ib[i1]]=0.;

        if(i0>=0) {
          red[ib[i0]]=0.;
          pt0=atm;
          while(pt0->row<i0) pt0=pt0->next;
          axis=pt0->val;
          pt0->val=0.;
          for(i=0;i<ir;i++)
            vec_add(red,a_row[i],-redmax*pivot(i0,axis,atm,h+i,es1));
          nbs=ib[i0];ib[i0]=jn[j0];jn[j0]=nbs;
          mt[i0]=a[ib[i0]];
	  if((n0=ln[ib[i0]])!=-1){kcan[n0]=1;lcan[n0]=i0;}
          if((n0=ln[jn[j0]])!=-1){kcan[n0]=0;lcan[n0]=jn[j0];}
	}
        if(flag_non) {
	  for(i=0;i<ndim;i++) vcan[i]=-cnl[nd[i]];
          cal_grad_vec(nd,cnl,ddxp,atmn,maxstep);
	  for(i=0;i<ndim;i++) vcan[i]+=cnl[nd[i]];
	  for(i=0;i<ndim;i++) {
            if(kcan[i]==0) red[lcan[i]]-=vcan[i];
            else put_mat(&shp,lcan[i],vcan[i],0.);
	  }
          for(i=0;i<ir;i++) vec_add(red,a_row[i],vec_vec2(shp,h[i]));
          make_null(&shp);
	}
      }
    }
    if(ncs%1000==0)
      printf(" Revised Simplex %d %d %f\n",ncs,flag_deg,
                   obj_func(ir+jc,w,ddxp,cp,bias,ln,nd,ndim));
  }while(ncs<10000 && idc>0 && (i0!=-1||flag_init==0||(i0==-1&&redmax<es0))
                                                  && flag_return!=-3);

  if(flag_return==-3) {
    fp=fopen("cvt.tmp","a");
    fprintf(fp," Failure in the recalculation process in simplex!!\n");
    fclose(fp);
  }
  else if(i0==-1) flag_return=j0;

  for(i=0;i<ir;i++) make_null(a_row+i);
  free(a_row);
  free(red);  free(vcan);
  free(cnl);  free(ican);
  free(ucan);
  free(lcan); free(kcan);
  free(mt);
  make_null(&atm);
  make_null(&atmn);
  return(flag_return);
}




  int newton(ir,jc,ib,jn,ln,nd,ndim,
                              a,b,ddxp,cp,bias,h,w,sp,wg,es0,es1,es2,es3)
  int ir,jc,*ib,*jn,*ln,*nd,ndim;
  double *b,*w,*cp,*sp,*wg,bias,es0,es1,es2,es3;
  struct mat **a,**h,**ddxp;
{ int i,j,i0,j0,m0,n0,k0,idc,nbs,idcm,ncmax;
  int flag_opt,flag_return,flag_init,flag_piv,nnp,flag_init2;
  double maxstep,step,v;
  double axis,in_pro,dev,absd;
  struct mat *pt,*pt0,**ppt,*ptp0,*ptpn,**hess_row;
  struct mat **hess,*atm,**mt;
  double *red,*vcan,*cnl,*ucan,*scale,zero;
  int *ican,*jcan,*kcan,idce,idcd,idcf,idcb;
  FILE *fp;

  n0=2*ndim;
  red=darr1(n0);
  vcan=darr1(n0);
  ucan=darr1(n0);
  scale=darr1(n0);
  cnl=darr1(jc+ir);
  ican=iarr1(n0);
  jcan=iarr1(n0);
  kcan=iarr1(n0);
  mt=marr1(ir);
  hess=marr1(n0);
  hess_row=marr1(n0);
  atm=STNL;
  ptp0=STNL;
  ptpn=STNL;
  ncmax=5;
  maxstep=-1.;
  flag_piv=1;

  flag_return=-1;

  for(i=0;i<ir;i++) mt[i]=a[ib[i]];
  for(i=0;i<ir+jc;i++) cnl[i]=cp[i];

  idc=0;
  for(i=0;i<jc;i++) {
    i0=jn[i];
    if(w[i0]>0.){
      if(ln[i0]!=-1) ican[idc++]=i;
      else w[i0]=0.;
    }
  }

  zero=1.e-24;
  nnp=0;
  idcb=-1;

  flag_init2=1;

  do {
    nnp++;

 /****** Deleting Zero-value Basic Variables ************/

    flag_piv=1;
    flag_init=1;
    do {
      j0=-1;
      axis=0.;
      for(i=0;i<idc;i++) {
        mat_vec(&atm,h,a[jn[ican[i]]],es1);
        remove_zero(&atm,es1*10.);
        pt=atm;
        while(pt!=STNL) {
          if(w[ib[pt->row]]<=0.&&fabs(pt->val)>axis) {
            axis=fabs(pt->val);
            j0=i;
          }
          pt=pt->next;
        }
      }
      if(j0!=-1){
        mat_vec(&atm,h,a[jn[ican[j0]]],es1);
        m0=refine_solution_vec(0,ncmax,mt,h,a[jn[ican[j0]]],&atm,es1);
        remove_zero(&atm,es1*10.);
        axis=0.;
        pt=atm;
        while(pt!=STNL) {
          if(w[ib[pt->row]]<=0.&&fabs(pt->val)>axis) {
            axis=fabs(pt->val);
            pt0=pt;
	  }
          pt=pt->next;
        }

        if(flag_init&&(axis>1./es3||axis<es3||m0==ncmax)) {
          flag_init=0;
          if(refine_inverse_matrix(ir,mt,h,es1)) flag_return=-3;
          if(check_fsb(jc,ir,ib,jn,w,a,b,h,mt,es1,es2)) flag_return=-3;
        }
        else {
          flag_return=-2;
          flag_init=1;
          axis=pt0->val;
          i0=pt0->row;
          pt0->val=0.;
          nbs=ib[i0];
          ib[i0]=jn[ican[j0]];
          jn[ican[j0]]=nbs;
          mt[i0]=a[ib[i0]];
          w[nbs]=0.;
          for(i=j0;i<idc-1;i++) ican[i]=ican[i+1];
          idc--;
          for(i=0;i<ir;i++) pivot(i0,axis,atm,h+i,es1);
	}
      }
    }while (j0!=-1);

/***************  Newton Raphson Method ********************/

 /*** Calculation of Shadow Prices and Checking Optimality ***/

    cal_grad(ndim,nd,w,cnl,ddxp,cp);
    cal_sp(ir,ib,cnl,h,sp);
    m0=refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
    if(m0==ncmax){
      if(refine_inverse_matrix(ir,mt,h,es1)) flag_return=-3;
      cal_sp(ir,ib,cnl,h,sp);
      refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
    }

    flag_opt=0;
    for(i=0;i<idc;i++){
      red[i]=cnl[jn[ican[i]]]-vec_vec(sp,a[jn[ican[i]]]);
      if(fabs(red[i])>es0) flag_opt=1;
    }

    m0=-1;
    if(flag_opt){

      flag_return=-2;

/*** Development of Hesssian and Its Modified Cholesky Decomposition ***/

      if(flag_piv<3) {
        for(i=0;i<idc;i++) jcan[i]=jn[ican[i]];
        idce=idc;
        for(i=0;i<ir;i++) if(ln[ib[i]]!=-1) jcan[idce++]=ib[i];
        for(i=0;i<ndim;i++) kcan[i]=-1;
        for(i=0;i<idce;i++) kcan[ln[jcan[i]]]=i;
        idcd=idce-idc;
        idcf=idcd+idce;
        for(i=0;i<idce;i++){
          make_null(hess+i);
          pt=ddxp[ln[jcan[i]]];
          while(pt!=STNL) {
            if((i0=kcan[pt->row])>=i) put_mat(hess+i,i0,pt->val,0.);
            pt=pt->next;
	  }
        }
        for(i=0;i<idc;i++) {
          mat_vec(&atm,h,a[jn[ican[i]]],es1);
          pt=atm;
          while(pt!=STNL) {
            if((i0=ln[ib[pt->row]])!=-1) 
              put_mat(hess+i,kcan[i0]+idcd,pt->val,0.);
            pt=pt->next;
          }
	}
        for(i=idc;i<idce;i++) put_mat(hess+i,i+idcd,1.,0.);
        for(i=0;i<idce;i++){
          if(hess[i]!=STNL&&hess[i]->row==i&&hess[i]->val>1.e-18)
            v=1./sqrt(hess[i]->val);
          else {
             add_mat(hess+i,i,1.e-18,0.);
             v=1.;
	  }
          pt=hess[i];
          while(pt!=STNL) {
            (pt->val)*=v;
            pt=pt->next;
	  }
          scale[i]=v;
	}
        transpose_mat2(hess,hess_row,idce,idcf);
        for(i=idce;i<idcf;i++) make_null(hess+i);
        for(i=0;i<idce;i++){
          v=scale[i];
          pt=hess_row[i];
          while(pt!=STNL) {
            (pt->val)*=v;
            pt=pt->next;
	  }
	}
        for(i=idce;i<idcf;i++){
          v=0.;
          pt=hess_row[i];
          while(pt!=STNL){
            if(v<fabs(pt->val)) v=fabs(pt->val);
            pt=pt->next;
	  }
          if(v!=0.) {
            pt=hess_row[i];
            while(pt!=STNL){
              (pt->val)/=v;
              pt=pt->next;
	    }
	  }
	}

        if(mod_cholesky_decomp(idcf,hess_row,hess,ucan,1.e-18)){
          printf(" Hessian is not positive definite!!\n");
          fp=fopen("cvt.tmp","a");
          fprintf(fp," Hessian is not positive definite!!\n");
          fclose(fp);
          for(i=0;i<idcf;i++) make_null(hess+i);
          flag_piv=0;
	}
      }

 /* Solving Moving Direction of Newton Raphson with MCD*/

      if(flag_piv!=0) {
        for(i=0;i<idc;i++) vcan[i]=red[i]*scale[i];
        for(i=idc;i<idcf;i++) vcan[i]=0.;
        for(i=0;i<idcf;i++) vcan[i]-=vec_vec(vcan,hess[i]);
        for(i=0;i<idcf;i++) vcan[i]*=ucan[i];
        for(i=idcf-1;i>=0;i--) vec_add(vcan,hess[i],-vcan[i]);
        for(i=0;i<idc;i++) vcan[i]*=scale[i];
      }
      else for(i=0;i<idc;i++) vcan[i]=red[i];

      flag_piv++;

      do {
        norm_v(idc,&absd,vcan);
        in_pro=0.;
        for(i=0;i<idc;i++) {
          if(fabs(vcan[i])<zero){vcan[i]=0.;red[i]=0.;}
          else in_pro+=vcan[i]*red[i];
        }
        if(in_pro<0.) for(i=0;i<idc;i++) vcan[i]=red[i];
      }while(in_pro<0.);

      make_null(&ptp0);
      for(i=0;i<idc;i++){
        v=vcan[i];
        if(v!=0.) {
          pt=a[jcan[i]];
          ppt=&ptp0;
          while(pt!=STNL){
            ppt=add_mat(ppt,pt->row,-v*(pt->val),0.);
            pt=pt->next;
          }
	}
      }
      mat_vec(&ptpn,h,ptp0,0.);
      m0=refine_solution_vec(0,ncmax,mt,h,ptp0,&ptpn,es1);
      remove_zero(&ptpn,es1);

      if(m0==ncmax&&flag_init2){
        flag_init2=0;
        if(refine_inverse_matrix(ir,mt,h,es1)) flag_return=-3;
      }
      else {
        flag_init2=1;
        make_null(&ptp0);
        for(i=0;i<idc;i++)
          if((i0=ln[jcan[i]])!=-1) put_mat(&ptp0,i0,vcan[i],0.);
        pt=ptpn;
        while(pt!=STNL) {
          if((i0=ln[ib[pt->row]])!=-1) put_mat(&ptp0,i0,pt->val,0.);
          pt=pt->next;
        }
        dev=der_redmax(ddxp,ptp0);
        make_null(&ptp0);
        maxstep=in_pro/dev;
        n0=-1;
        pt=ptpn;
        while(pt!=STNL){
          if(pt->val>0.){
            step=w[ib[pt->row]]/(pt->val);
            if(maxstep>step) {
              maxstep=step;
              n0=ib[pt->row];
            }
          }
          pt=pt->next;
        }
        if(maxstep<0.) maxstep=0.;
        if(maxstep==0.) zero*=100.;
        else zero=1.e-24;

        k0=-1;
        for(i=0;i<idc;i++) {
          if(vcan[i]>0.) {
            step=w[jcan[i]]/vcan[i];
            if(maxstep>step) {
              maxstep=step;
              k0=i;
            }
          }
        }
        if(maxstep<0.) maxstep=0.;

        pt=ptpn;
        while(pt!=STNL) {
          w[ib[pt->row]]-=maxstep*(pt->val);
          if(w[ib[pt->row]]<0.) w[ib[pt->row]]=0.;
          pt=pt->next;
        }
        for(i=0;i<idc;i++) {
          w[jcan[i]]-=maxstep*vcan[i];
          if(w[jcan[i]]<0.) w[jcan[i]]=0.;
        }
        if(k0!=-1) {
          n0=-1;
          w[jcan[k0]]=0.;
          for(i=k0;i<idc-1;i++) ican[i]=ican[i+1];
          idc--;
	}
        if(n0!=-1) w[n0]=0.;
      }
      make_null(&ptpn);
    }
    if(nnp%1000==0)
      printf(" Newton Raphson %d %d %f %d %d\n",nnp,idc,
                   obj_func(ir+jc,w,ddxp,cp,bias,ln,nd,ndim),m0,n0);

  } while (nnp<500 && flag_opt && flag_return!=-3);

  if(flag_return==-1) {
/*    cal_sp(ir,ib,cnl,h,sp);
    refine_shadow_price(ib,ir,jc,0,ncmax,mt,h,cnl,sp,es0);
*/    for(i=0;i<ir;i++) wg[ib[i]]=0.;
    for(i=0;i<jc;++i){
      j=jn[i];
      wg[j]=cnl[j]-vec_vec(sp,a[j]);
      if(wg[j]<-es0) printf("##### %d %f %f\n",ln[j],wg[j],w[j]);
    }
  }
  else if(flag_return==-3) {
    fp=fopen("cvt.tmp","a");
    fprintf(fp," Failure in Newton Raphson!!\n");
    fclose(fp);
  }

  for(i=0;i<2*ndim;i++) make_null(hess+i);
  for(i=0;i<2*ndim;i++) make_null(hess_row+i);
  make_null(&atm);
  free(mt); free(hess); free(hess_row);
  free(red); free(vcan); free(cnl); free(ucan); free(scale);
  free(ican);  free(jcan); free(kcan);
  return(flag_return);
}




  int mod_cholesky_decomp(mdim,amat,bmat,cmat,es1)
  int mdim;
  double *cmat,es1;
  struct mat **amat,**bmat;
{ int i,j;
  double v,u;
  struct mat *pt,**ppt,**dmat,*pt1,***pdmat;

  dmat=marr1(mdim);
  pdmat=malloc(Size_of_struct_mat_pt_pt*mdim);
  for(i=0;i<mdim;i++) pdmat[i]=dmat+i;

  for(i=0;i<mdim;i++) {
    pt=amat[i];
    ppt=bmat+i;
    while(pt!=STNL&&pt->row<i) {
      ppt=put_mat(ppt,pt->row,pt->val,0.);
      pt=pt->next;
    }
    if(pt!=STNL&&pt->row==i) cmat[i]=pt->val;
    else cmat[i]=0.;
    pt=bmat[i];
    while(pt!=STNL) {
      pt1=dmat[pt->row];
      ppt=bmat+i;
      while(pt1!=STNL) {
        ppt=add_mat(ppt,pt1->row,-(pt1->val)*(pt->val),es1);
        pt1=pt1->next;
      }
      pt=pt->next;
    }
    v=0.;
    pt=bmat[i];
    while(pt!=STNL) {
      u=pt->val;
      j=pt->row;
      (pt->val)/=cmat[j];
      v+=(pt->val)*u;
      pt1=get_mem(STNL,i,pt->val);
      *pdmat[j]=pt1;
      pdmat[j]=&(pt1->next);
      pt=pt->next;
    }
    cmat[i]-=v;
    if(cmat[i]==0.) return(1);
  }
  for(i=0;i<mdim;i++) cmat[i]=1./cmat[i];
  for(i=0;i<mdim;i++) make_null(dmat+i);
  free(dmat);
  free(pdmat);
  return(0);
}


  void cal_sp(ir,ib,c,h,sp)
  int ir,*ib;
  double *c,*sp;
  struct mat **h;
{ int i;
  double v;
  struct mat *pt;

  for(i=0;i<ir;i++) {
    v=0.;
    pt=h[i];
    while(pt!=STNL) {
      while(pt!=STNL&&c[ib[pt->row]]==0.) pt=pt->next;
      if(pt!=STNL) {
        v+=c[ib[pt->row]]*(pt->val);
        pt=pt->next;
      }
    }
    sp[i]=v;
  }
}





  int quad_gene(f,n,x,jc,ddxp,c,me,nd,dev,ps)
  double (*f)(int,double *);
  int n,*nd;
  double *x,*c,*me,dev,*ps;
  struct mat **ddxp;
{ int i,j,i0,j0,k,ndim;
  double f0,s1,dg,v,u,x0,x1,rk,ek,ap,cp,ps0;
  struct mat *pt;

  for(i=0;i<jc;i++) x[i]*=ps[i];
  f0=(*f)(n,x);

  ndim=0;
  for(k=0;k<N_BLK;k++) {
    for(i=0;i<2;i++) {
      i0=jv[0][i][k];
	  nd[ndim]=i0;
      u=0.;
      v=rgdk[n][i][0];
      j0=0;
      while(v<x[i0]&& j0<N_RGRADE-1) {
        ++j0;
        u=v;
        v+=rgdk[n][i][j0];
      }
      v=x[i0]-u;
      c[i0]=ps[i0]*(cbase[n][i0]+2*slope_df[n][i][j0][k]*v+rpck[n][i][j0][k]);
      put_mat(ddxp+ndim,ndim,ps[i0]*ps[i0]*2.*slope_df[n][i][j0][k],0.);
      ndim++;
    }
  }

  if(ictrl1==1) {
    if(ictrl8==0) {
      for(k=0;k<N_BLK;k++) {
        for(i=0;i<N_DEM;i++) {
          i0=jv[1][i][k];
		  nd[ndim]=i0;
          u=prelas[n][i];
          v=(rdemak[n][i][k]+x[i0])/cdemak[n][i][k];
          c[i0]=ps[i0]*(cbase[n][i0]-(u+1.)
            *enecon_f[n][i][k]*pow(v,u)/cdemak[n][i][k]);
          put_mat(ddxp+ndim,ndim,-ps[i0]*ps[i0]/cdemak[n][i][k]/cdemak[n][i][k]
                            *enecon_f[n][i][k]*(u+1.)*u*pow(v,u-1.),0.);
          ndim++;
       }
      }
    }
    else {
 	  rk=1./klelas[n];
	  ek=klelas[n]/enelas[n];
      for(k=0;k<N_BLK;k++) {
        ap=prod_a[n][k];
	    cp=prod_c[n][k];
        v=0.;
        for(i=0;i<N_DEM;i++) {
          x1=(rdemak[n][i][k]+x[jv[1][i][k]])/cdemak[n][i][k];
          v+=prod_b[n][i][k]*pow(x1,enelas[n]);
        }
		x0=(x[jv[2][1][k]]+rkap[n][k])/kapk[n][k];
        u=ap*pow(x0,cp)+pow(v,ek);
		i0=jv[2][1][k];
		nd[ndim]=i0;
		ps0=ps[i0];
        s1=ps0*ap*cp/kapk[n][k]*pow(u,rk-2.)*pow(x0,cp-2.);
        c[i0]=ps0*cbase[n][i0]-s1*rk*u*x0;
		dg=-rk*s1*((rk-1.)*ap*cp*pow(x0,cp)+u*(cp-1.))/kapk[n][k]*ps0;
		put_mat(ddxp+ndim,ndim,dg,0.);
        for(i=0;i<N_DEM;i++) {
          i0=jv[1][i][k];
		  x1=(x[i0]+rdemak[n][i][k])/cdemak[n][i][k];
		  dg=-s1*(rk-1.)*x0*pow(v,ek-1.)*prod_b[n][i][k]/cdemak[n][i][k]
			  *pow(x1,enelas[n]-1.)*ps[i0];
		  put_mat(ddxp+ndim,ndim+i+1,dg,0.);
		  put_mat(ddxp+ndim+i+1,ndim,dg,0.);
		}
        ndim++;
        for(i=0;i<N_DEM;i++) {		
          i0=jv[1][i][k];
  		  nd[ndim]=i0;
		  ps0=ps[i0];
  		  x0=(x[i0]+rdemak[n][i][k])/cdemak[n][i][k];
		  s1=ps0*prod_b[n][i][k]/cdemak[n][i][k]
			  *pow(u,rk-2.)*pow(v,ek-2.)*pow(x0,enelas[n]-2.);
		  c[i0]=ps0*cbase[n][i0]-s1*u*v*x0;
		  dg=-s1/cdemak[n][i][k]*ps0
			  *(((1.-klelas[n])*pow(v,ek)+(klelas[n]-enelas[n])*u)
			  *prod_b[n][i][k]*pow(x0,enelas[n])+u*v*(enelas[n]-1.));
		  put_mat(ddxp+ndim,ndim,dg,0.);
		  for(j=i+1;j<N_DEM;j++) {
			i0=jv[1][j][k];
			x1=(x[i0]+rdemak[n][j][k])/cdemak[n][j][k];
		    dg=-s1*x0*prod_b[n][j][k]/cdemak[n][j][k]*ps[i0]*pow(x1,enelas[n]-1.)
			  *((1.-klelas[n])*pow(v,ek)+(klelas[n]-enelas[n])*u);
 		    put_mat(ddxp+ndim,ndim+j-i,dg,0.);
		    put_mat(ddxp+ndim+j-i,ndim,dg,0.);
		  }
		  ndim++;
		}
	  }
    }
  }
  for(k=0;k<N_BLK;k++) {
	if(damage[n][k]!=0.){
      i0=jv[2][0][k];
	  nd[ndim]=i0;
      c[i0]=ps[i0]*(cbase[n][i0]+damage[n][k]*mepm[n]*pow(x[i0],mepm[n]-1.));
      put_mat(ddxp+ndim,ndim,ps[i0]*ps[i0]*damage[n][k]*
                    mepm[n]*(mepm[n]-1.)*pow(x[i0],mepm[n]-2.),0.);
      ndim++;
	}
  }
  for(i=0;i<jc;i++) x[i]/=ps[i];
  for(i=0;i<ndim;i++) {
    pt=ddxp[i];
    while(pt!=STNL) {
      c[nd[pt->row]]-=x[nd[i]]*(pt->val);
      pt=pt->next;
    }
  }
  me[n]=f0;
  for(i=0;i<jc;i++) me[n]-=c[i]*x[i];
  for(i=0;i<ndim;i++) {
    v=0.;
    pt=ddxp[i];
    while(pt!=STNL) {
      v+=x[nd[pt->row]]*(pt->val);
      pt=pt->next;
    }
    me[n]-=x[nd[i]]*v*0.5;
  }
  return(ndim);
}


 double obj_func(i0,w,ddxp,cp,bias,ln,nd,ndim)
 int *ln,*nd,ndim;
 double *w,*cp,bias;
 struct mat **ddxp;
{ double f,f1;
  int i;
  struct mat *pt;

  f=bias;
  for(i=0;i<i0;i++)  f+=cp[i]*w[i];
  for(i=0;i<ndim;i++) {
    pt=ddxp[i];
    f1=0.;
    while(pt!=STNL) {
      f1+=w[nd[pt->row]]*(pt->val);
      pt=pt->next;
    }
    f+=w[nd[i]]*f1*0.5;
  }
  return(f);
}


  int check_fsb(jc,ir,ib,jn,w,a,b,h,mt,es1,es2)
  int jc,ir,*ib,*jn;
  double *w,*b,es1,es2;
  struct mat **a,**h,**mt;
{ int i,flag,j,ncmax,nbs,j0;
  double *bt,v,axis;
  struct mat *pt,*atm;
  FILE *fp;

  bt=darr1(ir);
  atm=STNL;
  ncmax=4;

  for(j=0;j<ncmax;j++) {
    for(i=0;i<ir;i++) bt[i]=b[i];
    for(i=0;i<jc+ir;i++) if(w[i]>0.) vec_add(bt,a[i],-w[i]);
    v=0.;
    for(i=0;i<ir;i++) {
      v+=fabs(bt[i]);
      pt=h[i];
      while(pt!=STNL) {
        w[ib[pt->row]]+=bt[i]*(pt->val);
        pt=pt->next;
      }
    }
  }

  for(i=0;i<ir;i++) if(fabs(w[ib[i]])<es1/1000.) w[ib[i]]=0.;
  flag=0;
  v=0.;
  for(i=0;i<ir;i++) {
    if(w[ib[i]]<-es2) {
      j0=-1;
      axis=0.;
      for(j=0;j<jc;j++) {
        if(w[jn[j]]>es2) {
	  mat_vec(&atm,h,a[jn[j]],es1);
          pt=atm;
          while(pt!=STNL) {
            if(pt->row==i&&axis<fabs(pt->val)) {
              j0=j;
              axis=fabs(pt->val);
	    }
            pt=pt->next;
	  }
	}
      }

      if(j0!=-1) {
        mat_vec(&atm,h,a[jn[j0]],es1);
        refine_solution_vec(0,4,mt,h,a[jn[j0]],&atm,es1);
        remove_zero(&atm,es1);
        pt=atm;
        STNL->row=i;
        while(pt->row<i) {pt=pt->next;}
        axis=pt->val;
        pt->val=0.;
        for(j=0;j<ir;j++) pivot(i,axis,atm,h+j,es1);
        nbs=ib[i];
        ib[i]=jn[j0];
        jn[j0]=nbs;
        w[nbs]=0.;
        mt[i]=a[ib[i]];
        flag=check_fsb(jc,ir,ib,jn,w,a,b,h,mt,es1,es2);
      }
      else {
        v=w[ib[i]];
        flag=1;
        printf(" fsb diff =%e\n",v);
        fp=fopen("cvt.tmp","a");
        fprintf(fp," Infeasible %e!!\n",v);
        fclose(fp);
      }
      break;
    }
  }
  make_null(&atm);
  free(bt);
  return(flag);
}


 int refine_solution_vec(i0,ncmax,mt,h,atp,atm,es1)
 int i0,ncmax;
 struct mat **h,**atm,**mt,*atp;
 double es1;
{ struct mat *att,*btt,*pt,**ppt;
  double u,zero;

  if(i0>=ncmax) return(ncmax);

  att=STNL;
  btt=STNL;
  i0++;
  zero=pow(es1,4.);
  zero=0.;

  mat_vec(&att,mt,*atm,zero);
  pt=atp;
  ppt=&att;
  while(pt!=STNL) {
    ppt=add_mat(ppt,pt->row,-(pt->val),zero);
    pt=pt->next;
  }
  u=0.;
  pt=att;
  while(pt!=STNL) {
    u+=fabs(pt->val);
    pt=pt->next;
  }
  if(u>es1*es1){
    mat_vec(&btt,h,att,zero);
    i0=refine_solution_vec(i0,ncmax,mt,h,att,&btt,es1);
    ppt=atm;
    pt=btt;
    while(pt!=STNL) {
      ppt=add_mat(ppt,pt->row,-(pt->val),zero);
      pt=pt->next;
    }
  }
  make_null(&att);
  make_null(&btt);
  return(i0);
}


 int refine_shadow_price(ib,ir,jc,i0,ncmax,mt,h,cp,sp,es0)
 int *ib,ir,jc,i0,ncmax;
 struct mat **h,**mt;
 double *cp,*sp,es0;
{ struct mat *pt;
  double v,u,*cptm,*sptm;
  int i;

  if(i0>=ncmax) return(ncmax);

  cptm=darr1(ir+jc);
  sptm=darr1(ir);

  i0++;
  u=0.;
  for(i=0;i<ir;i++) {
    v=-cp[ib[i]];
    pt=mt[i];
    while(pt!=STNL) {
      v+=sp[pt->row]*pt->val;
      pt=pt->next;
    }
    cptm[ib[i]]=v;
    u+=fabs(v);
  }
  if(u>es0/1000.){
    cal_sp(ir,ib,cptm,h,sptm);
    i0=refine_shadow_price(ib,ir,jc,i0,ncmax,mt,h,cptm,sptm,es0);
    for(i=0;i<ir;i++) sp[i]-=sptm[i];
  }
  free(cptm);
  free(sptm);
  return(i0);
}



 int refine_inverse_matrix(ir,mt,h,es1)
 int ir;
 struct mat **mt,**h;
 double es1;
{ int i,m0,m0_max,nc_max;
  struct mat *pt;
  FILE *fp;

  nc_max=6;

  pt=get_mem(STNL,0,1.);
  m0_max=0;
  for(i=0;i<ir;i++) {
    pt->row=i;
    m0=refine_solution_vec(0,nc_max,mt,h,pt,h+i,es1);
    if(m0>m0_max) m0_max=m0;
    remove_zero(h+i,es1);
    if(m0_max>=nc_max) break;
  }
  m0_max=0;
  for(i=ir-1;i>=0;i--) {
    pt->row=i;
    m0=refine_solution_vec(0,nc_max,mt,h,pt,h+i,es1);
    if(m0>m0_max) m0_max=m0;
    remove_zero(h+i,es1);
    if(m0_max>=nc_max) break;
  }
  make_null(&pt);

  if(m0_max>=nc_max) {
    printf(    " Matrix Inversion %d \n",ir);
    fp=fopen("cvt.tmp","a");
    fprintf(fp," Matrix Inversion %d \n",ir);
    fclose(fp);
    return(init_mat(ir,mt,h,es1));
  }
  else return(0);
}



  double pivot(i0,axis,atp,vec,es1)
  int i0;
  double axis,es1;
  struct mat *atp,**vec;
{ double v;
  struct mat *pt,**ppt;

  v=0.;
  STNL->row=i0;
  pt=*vec;
  while(pt->row<i0) pt=pt->next;
  if(pt!=STNL&&pt->row==i0) {
    v=(pt->val)/axis;
    pt->val=v;
    pt=atp;
    ppt=vec;
    while(pt!=STNL) {
      ppt=add_mat(ppt,pt->row,-v*(pt->val),es1);
      pt=pt->next;
    }
  }
  if(fabs(v)<es1) v=0.;
  return(v);
}


  int init_mat(ir,mt,h,es1)
  int ir;
  struct mat **mt,**h;
  double es1;
{ int i;
  struct mat *pt,*pt0,*pt1;

  for(i=0;i<ir;i++) {
    make_null(h+i); 
    pt=mt[i];
    pt0=STNL;
    while(pt!=STNL) {
      pt1=get_mem(STNL,pt->row,pt->val);
      if(pt0==STNL) h[i]=pt1;
      else pt0->next=pt1;
      pt0=pt1;
      pt=pt->next;
    }
  }
  return(invmat(ir,h,es1));
}


  int invmat(mdim,mat,zero)
  int mdim;
  struct mat **mat;
  double zero;
{ int i,j,i0,iflag;
  int *kd,*nd;
  struct mat *pt0,*pt,**ppt,**tma,*pt1;
  double dm,v;
  FILE *fp;

  kd=iarr1(mdim);  
  nd=iarr1(mdim);
  tma=marr1(mdim);  

  iflag=0;

  for(i=0;i<mdim;i++) nd[i]=1;

  for(j=0;j<mdim;j++) {
    dm=0.;
    pt=mat[j];
    while(pt!=STNL) {
      if(nd[pt->row]==1&&fabs(pt->val)>dm) {
        dm=fabs(pt->val);
        pt0=pt;
      }
      pt=pt->next;
    }
    if(dm<zero||dm>1./zero) { iflag=1; break; }
    i0=pt0->row;
    dm=1./(pt0->val);
    pt0->val=0.;
    kd[i0]=j;
    nd[i0]=0;
    for(i=0;i<mdim;i++) {
      if(i!=j) {
        STNL->row=i0;
        pt=mat[i];
        while(pt->row<i0) pt=pt->next;
        if(pt!=STNL&&pt->row==i0) {
          v=(pt->val)*dm;
          pt->val=v;
          pt=mat[j];
          ppt=mat+i;
          while(pt!=STNL) {
            ppt=add_mat(ppt,pt->row,-v*(pt->val),zero);
            pt=pt->next;
          }
	}
      }
    }
    pt0->val=-1.;
    pt=mat[j];
    pt0=STNL;
    while(pt!=STNL) {
      v=-(pt->val)*dm;
      if(fabs(v)>zero){ pt->val=v; pt0=pt; pt=pt->next; }
      else {
        pt1=pt->next;
        free_mem(pt);
        pt=pt1;
        if(pt0!=STNL) pt0->next=pt;
        else mat[j]=pt;
      }
    }
  }
  if(iflag) {
    printf(    " Matrix is singular %d !!\n",j);
    fp=fopen("cvt.tmp","a");
    fprintf(fp," Matrix is singular!! %d\n",mdim);
    fclose(fp);
  }
  else {
    for(i=0;i<mdim;i++) tma[i]=mat[i];
    for(i=0;i<mdim;i++) mat[i]=tma[kd[i]];
    for(i=0;i<mdim;i++) tma[i]=STNL;
    transpose_mat2(mat,tma,mdim,mdim);
    for(i=0;i<mdim;i++) mat[i]=tma[i];
    for(i=0;i<mdim;i++) tma[kd[i]]=mat[i];
    for(i=0;i<mdim;i++) mat[i]=STNL;
    transpose_mat2(tma,mat,mdim,mdim);
  }
  free(kd); free(nd); free(tma);
  return(iflag);
}


 void cal_grad(ndim,nd,w,dw,ddxp,cp)
 int ndim,*nd;
 double *w,*dw,*cp;
 struct mat **ddxp;
{ int i;
  struct mat *pt;
  for(i=0;i<ndim;i++) {
    dw[nd[i]]=cp[nd[i]]; 
    pt=ddxp[i];
    while(pt!=STNL) {
      dw[nd[i]]+=w[nd[pt->row]]*(pt->val);
      pt=pt->next;
    }
  }
}

 void cal_grad_vec(nd,dw,ddxp,vec,maxstep)
 int *nd;
 double *dw,maxstep;
 struct mat **ddxp,*vec;
{ struct mat *pt,*pt1;
  pt1=vec;
  while(pt1!=STNL) {
    pt=ddxp[pt1->row];
    while(pt!=STNL) {
      dw[nd[pt->row]]+=maxstep*(pt1->val)*(pt->val);
      pt=pt->next;
    }
    pt1=pt1->next;
  }
}

  double der_redmax(ddxp,atmn)
  struct mat **ddxp,*atmn;
{ double dst;
  struct mat *devpt;
  devpt=STNL;
  mat_vec(&devpt,ddxp,atmn,0.);
  dst=vec_vec2(devpt,atmn);
  make_null(&devpt);
  return(dst);
}


  void mat_vec(vec,mat,pt,zero)
  struct mat **mat,**vec,*pt;
  double zero;
{ struct mat **ppt,*pt0;
  double v;
  v=zero*zero*zero*zero;
  make_null(vec);
  while(pt!=STNL) {
    ppt=vec;
    pt0=mat[pt->row];
    while(pt0!=STNL) {
      ppt=add_mat(ppt,pt0->row,(pt0->val)*(pt->val),v);
      pt0=pt0->next;
    }
    pt=pt->next;
  }
  remove_zero(vec,zero);
}



  double vec_vec(vec,pt)
  double *vec;
  struct mat *pt;
{ double v;
  v=0.;
  while(pt!=STNL) {
    while(pt!=STNL&&vec[pt->row]==0.) pt=pt->next;
    if(pt!=STNL) {
      v+=vec[pt->row]*(pt->val);
      pt=pt->next;
    }
  }
  return(v);
}


  double vec_vec2(pt1,pt2)
  struct mat *pt1,*pt2;
{ double v;
  v=0.;
  while(pt1!=STNL&&pt2!=STNL) {
    if((pt1->row)<(pt2->row)) {
      STNL->row=pt2->row;
      while(pt1->row<pt2->row) pt1=pt1->next;
    }
    else if(pt1->row>pt2->row) {
      STNL->row=pt1->row;
      while(pt2->row<pt1->row) pt2=pt2->next;
    }
    else {
      v+=(pt1->val)*(pt2->val);
      pt1=pt1->next;
      pt2=pt2->next;
    }
  }
  return(v);
}


  double vec_vec3(vec,pt,ib)
  double *vec;
  struct mat *pt;
  int *ib;
{ double v;
  v=0.;
  while(pt!=STNL) {
    while(pt!=STNL&&vec[ib[pt->row]]==0.) pt=pt->next;
    if(pt!=STNL) {
      v+=vec[ib[pt->row]]*(pt->val);
      pt=pt->next;
    }
  }
  return(v);
}


  void vec_add(vec,pt,val)
  double *vec,val;
  struct mat *pt;
{
  if(val!=0.)
    while(pt!=STNL){
      vec[pt->row]+=val*(pt->val);
      pt=pt->next;
    }
}


  struct mat **put_mat(ppt,i,v,zero)
  struct mat **ppt;
  int i;
  double v,zero;
{ struct mat *pt;
  STNL->row=i;
  while((*ppt)->row<i) ppt=&((*ppt)->next);
  pt=*ppt;
  if(pt!=STNL&&pt->row==i) {
    if(fabs(v)>zero) pt->val=v;
    else {
      *ppt=pt->next;
      free_mem(pt);
    }
  }
  else if(fabs(v)>zero) *ppt=get_mem(pt,i,v);
  return(ppt);
} 


  struct mat **add_mat(ppt,i,v,zero)
  struct mat **ppt;
  int i;
  double v,zero;
{ struct mat *pt;
  STNL->row=i;
  while((*ppt)->row<i) ppt=&((*ppt)->next);
  pt=*ppt;
  if(pt!=STNL&&pt->row==i) {
    v+=(pt->val);
    if(fabs(v)>zero) pt->val=v;
    else {
      *ppt=pt->next;
      free_mem(pt);
    }
  }
  else if(fabs(v)>zero) *ppt=get_mem(pt,i,v);
  return(ppt);
}


  void remove_zero(ppt,zero)
  struct mat **ppt;
  double zero;
{ struct mat *pt;
  while((*ppt)!=STNL) {
    pt=*ppt;
    if(fabs(pt->val)<zero) {
      *ppt=pt->next;
      free_mem(pt);
    }
    else ppt=&(pt->next);
  }
}


  void transpose_mat(pt1,pt2,i0,j0)
  struct mat **pt1,**pt2;
  int i0,j0;
{ int i,j;
  struct mat *pt,*pt0;
  for(i=0;i<j0;i++) make_null(pt2+i);
  for(i=i0-1;i>=0;i--) {
    pt=pt1[i];
    while(pt!=STNL) {
      j=pt->row;
      pt0=pt2[j];
      pt2[j]=get_mem(pt0,i,pt->val);
      pt=pt->next;
    }
  }
}


  void transpose_mat2(pt1,pt2,i0,j0)
  struct mat **pt1,**pt2;
  int i0,j0;
{ int i;
  struct mat *pt,*pt0;
  for(i=0;i<j0;i++) make_null(pt2+i);
  for(i=i0-1;i>=0;i--) {
    pt=pt1[i];
    while(pt!=STNL) {
      pt0=pt->next;
      pt->next=pt2[pt->row];
      pt2[pt->row]=pt;
      pt->row=i;
      pt=pt0;
    }
    pt1[i]=STNL;
  }
}

  struct mat *get_mem(pt1,i0,v0)
  struct mat *pt1;
  int i0;
  double v0;
{ struct mat *pt;
  if(Memo_list!=STNL) {
    pt=Memo_list; Memo_list=Memo_list->next;
  }
  else {
    if(NULL==(pt=(struct mat *) malloc(Size_of_struct_mat))) {
      printf(" There is no enough memory!!\n");
      exit(0);
    }
    else 
      Memo_count++;
  }
  pt->next=pt1;
  pt->row=i0;
  pt->val=v0;
  return(pt);
}


   void free_mem(pt)
   struct mat *pt;
{  struct mat *pt0;
   pt0=Memo_list; Memo_list=pt; Memo_list->next=pt0;
 }


  void make_null(ppt)
  struct mat **ppt;
{ struct mat *pt,*pt0;
  pt=*ppt;
  *ppt=STNL;
  while(pt!=STNL) {pt0=pt->next; free_mem(pt); pt=pt0;}
}




  int del_nonl_var(lr,ir,jc,ib,jn,ln,a,h,g,es0,es1)
  int lr,ir,jc,**ib,**jn,**ln;
  struct mat ***a,***h;
  double **g,es0,es1;
{ int n,i,i0,j0,m0,nbs,flag,ncmax,flag1;
  double axis;
  struct mat *atm,*atm2,*pt,*pt0,**mt;
  ncmax=4;
  atm=STNL;
  atm2=STNL;
  mt=marr1(ir);
  flag=0;
  for(n=0;n<lr;n++) {
    for(i=0;i<ir;i++) mt[i]=a[n][ib[n][i]];
    do {
      axis=0.;
      pt0=STNL;
      for(i=0;i<jc;i++){
        i0=jn[n][i];
        if(ln[n][i0]==-1&&g[n][i0]<es0) {
          mat_vec(&atm,h[n],a[n][i0],es1);
          m0=refine_solution_vec(0,ncmax,mt,h[n],a[n][i0],&atm,es1);
          if(m0==ncmax)	{
            refine_inverse_matrix(ir,mt,h[n],es1);
            mat_vec(&atm,h[n],a[n][i0],es1);
            refine_solution_vec(0,ncmax,mt,h[n],a[n][i0],&atm,es1);
	  }
          remove_zero(&atm,es1);
          pt=atm;
          flag1=0;
          while(pt!=STNL) {
            if(ln[n][ib[n][pt->row]]!=-1&&fabs(pt->val)>axis) {
              axis=fabs(pt->val);
              j0=i;
              pt0=pt;
              flag1=1;
	    }
            pt=pt->next;
	  }
          if(flag1) {
            make_null(&atm2);
            atm2=atm;
            atm=STNL;
	  }
	}
      }
      if(pt0!=STNL) {
        axis=pt0->val;
        pt0->val=0.;
        i0=pt0->row;
        for(i=0;i<ir;i++) pivot(i0,axis,atm2,h[n]+i,es1);
        nbs=ib[n][i0];
        ib[n][i0]=jn[n][j0];
        jn[n][j0]=nbs;
        flag=1;
        mt[i0]=a[n][ib[n][i0]];
      }
    } while(pt0!=STNL);
  }
  make_null(&atm);
  make_null(&atm2);
  free(mt);
  return(flag);
}


  int del_artvar(ir,jct,num,a,b,h,w,ib,jn,ln,es1,es2)
  int ir,jct,num,*ib,*jn,*ln;
  double *w,*b,es1,es2;
  struct mat **a,**h;
{ int i,j,j0,flag,k;
  double axis,at,*hv;
  struct mat *pt,**mt,*atm;
  FILE *fp;

  mt=marr1(ir);
  atm=STNL;

  flag=0;
  for(i=0;i<ir;i++) {
    if(ib[i]>=jct && w[ib[i]]>es2) {
      printf(" There is no feasible solutions.\n");
      fp=fopen("cvt.tmp","a");
      fprintf(fp," There is no feasible solutions.\n");
      fclose(fp);
      exit(0);
    }
  }

  for(i=0;i<ir;i++) mt[i]=a[ib[i]];

  hv=darr1(ir);
  while (num>jct-ir) {
    for(i=0;i<ir;i++) {
      if(ib[i]>=jct) {
        axis=0.;
        j0=-1;
        for(j=0;j<ir;j++) {
          pt=h[j];
          STNL->row=i;
          while(pt->row<i) pt=pt->next;
          if(pt!=STNL&&pt->row==i) hv[j]=pt->val;
          else hv[j]=0.;
	}
        for(j=0;j<num;j++){
          at=0.;
          pt=a[jn[j]];
          while(pt!=STNL) {
            at+=(pt->val)*hv[pt->row];
            pt=pt->next;
	  }
          if(fabs(at)>axis) {
            axis=fabs(at);
            j0=j;
	  }
	}
        if(j0==-1) {
          printf("  Failure in deleting artificial variables!!\n");
          fp=fopen("cvt.tmp","a");
          fprintf(fp,"  Failure in deleting artificial variables!!\n");
          fclose(fp);
          exit(0);
	}
        else {
	  flag=1;
          mat_vec(&atm,h,a[jn[j0]],es1);
          refine_solution_vec(0,4,mt,h,a[jn[j0]],&atm,es1);
          remove_zero(&atm,es1);
          pt=atm;
          STNL->row=i;
          while(pt->row<i) {pt=pt->next;}
          if(pt!=STNL&&pt->row==i){
            axis=pt->val;
            pt->val=0.;
	  }
          for(k=0;k<ir;k++) pivot(i,axis,atm,h+k,es1);
          ib[i]=jn[j0];
          (num)--;
          jn[j0]=jn[num];
          mt[i]=a[ib[i]];
	  refine_inverse_matrix(ir,mt,h,es1);
          w[ib[i]]=0.;
	}
      }
    }
  }
  free(hv);
  free(mt);
  make_null(&atm);
  return(flag);
}


 double *darr1(i0)
 int i0;
{ double *mdar;
  mdar=(double *) malloc(i0*Size_of_double);
  return(mdar);
}

 double **darr2(i0,j0)
 int i0,j0;
{ int i;
  double **mdar;
  mdar=(double **) malloc(i0*Size_of_double_pt);
  for(i=0;i<i0;i++) mdar[i]=darr1(j0);
  return(mdar);
}

 double ***darr3(i0,j0,k0)
 int i0,j0,k0;
{ int i;
  double ***mdar;
  mdar=(double ***) malloc(i0*Size_of_double_pt2);
  for(i=0;i<i0;i++) mdar[i]=darr2(j0,k0);
  return(mdar);
}

 double ****darr4(i0,j0,k0,m0)
 int i0,j0,k0,m0;
{ int i;
  double ****mdar;
  mdar=(double ****) malloc(i0*Size_of_double_pt3);
  for(i=0;i<i0;i++) mdar[i]=darr3(j0,k0,m0);
  return(mdar);
}

 int *iarr1(i0)
 int i0;
{ int *mdar;
  mdar=(int *) malloc(i0*Size_of_integer);
  return(mdar);
}

 int **iarr2(i0,j0)
 int i0,j0;
{ int i;
  int **mdar;
  mdar=(int **) malloc(i0*Size_of_integer_pt);
  for(i=0;i<i0;i++) mdar[i]=iarr1(j0);
  return(mdar);
}

 int ***iarr3(i0,j0,k0)
 int i0,j0,k0;
{ int i;
  int ***mdar;
  mdar=(int ***) malloc(i0*Size_of_integer_pt2);
  for(i=0;i<i0;i++) mdar[i]=iarr2(j0,k0);
  return(mdar);
}

 struct mat **marr1(i0)
 int i0;
{ int i;
  struct mat **mdar;
  mdar=(struct mat **) malloc(Size_of_struct_mat_pt*i0);
  for(i=0;i<i0;i++) mdar[i]=STNL;
  return(mdar);
}

 struct mat ***marr2(i0,j0)
 int i0,j0;
{ int i;
  struct mat ***mdar;
  mdar=(struct mat ***) malloc(Size_of_struct_mat_pt_pt*i0);
  for(i=0;i<i0;i++) mdar[i]=marr1(j0);
  return(mdar);
}

  void norm_v(id,u,v)
  int id;
  double *u,*v;
{ int i;
  double w;
  *u=0.;
  for(i=0;i<id;i++) *u+=v[i]*v[i];
  if(*u>0.) {
    *u=sqrt(*u);
    w=1./(*u);
    for(i=0;i<id;i++) v[i]*=w;
  }
  else  for(i=0;i<id;i++) v[i]=0.;
}

  void inter_rep(ke,nc,p,h)
  int ke,nc;
  double *p,h;
{ int i;
  FILE *fp;
  fp=fopen("pp.tmp","w");
  fprintf(fp," %d\n",nc);
  for(i=0;i<ke;i++) fprintf(fp," %f\n",p[i]);
  fclose(fp);
  fp=fopen("cvt.tmp","a");
  fprintf(fp," %15.5f\n",h);
  fclose(fp);
}


  void mat_scale(jc,ir,a,b,t,ps,qs,nc)
  struct mat **a,**t;
  int jc,ir,nc;
  double *b,*ps,*qs;
{ int i,j;
  double v,*min_p,*min_q;
  struct mat *pt;

  min_p=darr1(jc);
  min_q=darr1(ir);

  for(i=0;i<jc;i++)  ps[i]=1.;
  for(i=0;i<ir;i++)  qs[i]=1.;
  for(i=0;i<jc;i++)  min_p[i]=1.;
  for(i=0;i<ir;i++)  min_q[i]=1.;

  for(j=0;j<nc;j++) {
    for(i=0;i<jc;i++) ps[i]/=sqrt(min_p[i]);
    for(i=0;i<ir;i++) qs[i]/=sqrt(min_q[i]);
    for(i=0;i<jc;i++)  min_p[i]=1.e40;
    for(i=0;i<ir;i++)  min_q[i]=1.e40;
    for(i=0;i<jc;i++) {
      pt=a[i];
      while(pt!=STNL) {
        if(pt->row>=ir) {
          printf(" %d\n",pt->row);

          exit(0);
	}
        v=fabs(pt->val)*ps[i]*qs[pt->row];
        if(v<min_q[pt->row]) min_q[pt->row]=v;
        if(v<min_p[i]) min_p[i]=v;
        pt=pt->next;
      }
    }
  }

  for(i=0;i<jc;i++) {
    pt=a[i];
    while(pt!=STNL) {
      (pt->val)*=(ps[i]*qs[pt->row]);
      pt=pt->next;
    }
    pt=t[i];
    while(pt!=STNL) {
      (pt->val)*=ps[i];
      pt=pt->next;
    }
  }
  for(i=0;i<ir;i++) b[i]*=qs[i];

  free(min_p);
  free(min_q);
}



  void read_problem_file(lr,ir,jc,kel,nblk,ke,iinter,a,t0,t1,b,c,ev,isl,ksl)
  int *lr,*ir,*jc,*kel,*nblk,*ke,*iinter,**isl,**ksl;
  struct mat ****a,****t0,****t1;
  double ***b,***c,**ev;
{ int i,j,k,n,nc,i0,j0,n0;
  double v;
  FILE *fp;

  fp=fopen("cnst.tmp","r");
  fscanf(fp,"%d\n",lr);
  fscanf(fp,"%d\n",ir);
  fscanf(fp,"%d\n",jc);
  fscanf(fp,"%d\n",kel);
  fscanf(fp,"%d\n",nblk);
  fscanf(fp,"%d\n",ke);
  fscanf(fp,"%d\n",iinter);
  *a=marr2(*lr,*jc+2*(*ir));
  *t0=marr2(*lr,*jc+2*(*ir));
  *t1=marr2(*lr,*jc+2*(*ir));
  *b=darr2(*lr,*ir);
  *c=darr2(*lr,*jc);
  *ev=darr1(*ke);
  *isl=iarr1(*ir);
  *ksl=iarr1(*ke);

  fscanf(fp,"%d\n",&nc);
  for(i=0;i<nc;i++) {
    fscanf(fp,"%d %d %d %lf\n",&n0,&i0,&j0,&v);
    put_mat(&(*a)[n0][i0],j0,v,0.);
  }

  fscanf(fp,"%d\n",&nc);
  for(i=0;i<nc;i++) {
    fscanf(fp,"%d %d %d %lf\n",&n0,&i0,&j0,&v);
    put_mat(&(*t0)[n0][i0],j0,v,0.);
  }

  fscanf(fp,"%d\n",&nc);
  for(i=0;i<nc;i++) {
    fscanf(fp,"%d %d %d %lf\n",&n0,&i0,&j0,&v);
    put_mat(&(*t1)[n0][i0],j0,v,0.);
  }

  for(n=0;n<*lr;n++)
	for(i=0;i<*ir;i++)
	  fscanf(fp,"%lf\n",&(*b)[n][i]);

  for(i=0;i<*ke;i++)
	  fscanf(fp,"%lf\n",&(*ev)[i]);

  for(n=0;n<*lr;n++)
	for(i=0;i<*jc;i++)
	  fscanf(fp,"%lf\n",&(*c)[n][i]);

  for(i=0;i<*ir;i++)
	  fscanf(fp,"%d\n",&(*isl)[i]);

  for(i=0;i<*ke;i++)
	  fscanf(fp,"%d\n",&(*ksl)[i]);

  fclose(fp);

  fp=fopen("eval.tmp","r");
  fscanf(fp,"%d\n",&ictrl1);
  fscanf(fp,"%d\n",&ictrl6);
  fscanf(fp,"%d\n",&ictrl8);
  fscanf(fp,"%d\n",&N_REN);
  fscanf(fp,"%d\n",&N_DEM);
  fscanf(fp,"%d\n",&N_RGRADE);
  fscanf(fp,"%d\n",&N_TIME);

  jv=iarr3(3,N_DEM,*nblk);

  for(i=0;i<N_REN;i++)
    for(k=0;k<*nblk;k++)
      fscanf(fp," %d",&(jv[0][i][k]));
  while(getc(fp)!='\n');

  for(i=0;i<N_DEM;i++)
    for(k=0;k<*nblk;k++)
      fscanf(fp," %d",&jv[1][i][k]);
  while(getc(fp)!='\n');

  for(k=0;k<*nblk;k++)
    fscanf(fp," %d",&jv[2][0][k]);
  while(getc(fp)!='\n');

  for(k=0;k<*nblk;k++)
    fscanf(fp," %d",&jv[2][1][k]);
  while(getc(fp)!='\n');

  f_off_set=darr1(*lr);
  for(n=0;n<*lr;n++)
    fscanf(fp,"%lf\n",&f_off_set[n]);

 
  slope_f=darr4(*lr,N_REN,N_RGRADE,*nblk);
  slope_df=darr4(*lr,N_REN,N_RGRADE,*nblk);
  for(n=0;n<*lr;n++)
    for(i=0;i<N_REN;i++)
      for(j=0;j<N_RGRADE;j++)
        for(k=0;k<*nblk;k++)
  fscanf(fp," %lf %lf\n",&slope_f[n][i][j][k],&slope_df[n][i][j][k]);

  rgdk=darr3(*lr,N_REN,N_RGRADE);
  for(n=0;n<*lr;n++)
    for(i=0;i<N_REN;i++)
      for(j=0;j<N_RGRADE;j++)
         fscanf(fp," %lf\n",&rgdk[n][i][j]);

  rpck=darr4(*lr,N_REN,N_RGRADE+1,*nblk);
  for(n=0;n<*lr;n++)
    for(i=0;i<N_REN;i++)
      for(j=0;j<N_RGRADE+1;j++)
        for(k=0;k<*nblk;k++)
          fscanf(fp," %lf\n",&rpck[n][i][j][k]);

  damage=darr2(*lr,*nblk);
  for(n=0;n<*lr;n++)
    for(k=0;k<*nblk;k++)
      fscanf(fp," %lf\n",&damage[n][k]);

  mepm=darr1(*lr);
  for(n=0;n<*lr;n++)
    fscanf(fp," %lf\n",&mepm[n]);

  rdemak=darr3(*lr,N_DEM,*nblk);
  cdemak=darr3(*lr,N_DEM,*nblk);
  enecon_f=darr3(*lr,N_DEM,*nblk);
  prod_b=darr3(*lr,N_DEM,*nblk);

  for(n=0;n<*lr;n++)
    for(i=0;i<N_DEM;i++)
	  for(k=0;k<*nblk;k++)
        fscanf(fp," %lf %lf %lf %lf\n",&rdemak[n][i][k],
		&cdemak[n][i][k],&enecon_f[n][i][k],&prod_b[n][i][k]);

  prelas=darr2(*lr,N_DEM);
  for(n=0;n<*lr;n++)
    for(i=0;i<N_DEM;i++)
      fscanf(fp," %lf\n",&prelas[n][i]);

  enelas=darr1(*lr);
  klelas=darr1(*lr);
  for(n=0;n<*lr;n++)
    fscanf(fp," %lf %lf\n",&enelas[n],&klelas[n]);

  rkap=darr2(*lr,*nblk);
  kapk=darr2(*lr,*nblk);
  prod_a=darr2(*lr,*nblk);
  prod_c=darr2(*lr,*nblk);

  for(n=0;n<*lr;n++)
    for(k=0;k<*nblk;k++)
       fscanf(fp," %lf %lf %lf %lf\n",&rkap[n][k]
	   ,&kapk[n][k],&prod_a[n][k],&prod_c[n][k]);

  zdf=darr1(*nblk);
  for(k=0;k<*nblk;k++)
    fscanf(fp," %lf\n",&zdf[k]);

}


  int read_pp(krow,p)
  double *p;
  int krow;
{ FILE *fp;
  int i,nc;
  for(i=0;i<krow;i++) p[i]=0.;
  fp=fopen("pp.dat","r");
  fscanf(fp," %d\n",&nc);
  i=0;
  while(i<krow && fscanf(fp," %lf\n",p+i++)==1);
  fclose(fp);
  return(1);
}


  void output(nc,lr,ir,JC,ke,kel,nblk,x,g,sd,p,zdf)
  int nc,lr,ir,JC,ke,kel,nblk;
  double **x,**g,**sd,*p,*zdf;
{ int i,k,n;
  FILE *fp;

  fp=fopen("pp.out","w");
  fprintf(fp," %d\n",nc);
  for(i=0;i<ke;i++) fprintf(fp," %f\n",p[i]);
  fclose(fp);

  fp=fopen("result.out","w");
  fprintf(fp," %4d\n",JC);
  for(n=0;n<lr;n++)
    for(i=0;i<JC;i++) {
      if(x[n][i]>0.) fprintf(fp,"%15.5f 1\n",x[n][i]);
      else           fprintf(fp,"%15.5f 0\n",g[n][i]);
    }
  fprintf(fp," %4d\n",ir);
  for(n=0;n<lr;n++)
    for(i=0;i<ir;i++)
      fprintf(fp,"%15.5f\n",sd[n][i]);

  fprintf(fp," %4d\n",ke);
  for(i=0;i<nblk;i++) 
   for(k=0;k<kel;k++)
     fprintf(fp,"%15.5f\n",p[kel*i+k]/zdf[i]);
  fclose(fp);
}



 void write_sp(LR,a,sd,zdf)
 int LR;
 struct mat ***a;
 double **sd,*zdf;
{ FILE *fp;
  int i,j,k,n;
  double ***shdpri;

  shdpri=darr3(LR,N_DEM,N_TIME);

  for(n=0;n<LR;n++)
    for(i=0;i<N_DEM;i++)
      for(k=0;k<N_TIME;k++)
        shdpri[n][i][k]=0.;

  for(k=0;k<N_BLK;k++) {
    for(i=0;i<N_DEM;i++) {
      j=jv[1][i][k];
      for(n=0;n<LR;n++)
        shdpri[n][i][k]=-vec_vec(sd[n],a[n][j])/zdf[k];
    }
  }

  fp=fopen("shadow.dat","w");
  for(i=0;i<N_DEM;i++) {
    for(n=0;n<LR;n++) {
      fprintf(fp,"Region%2d:",n+1);
      for(k=0;k<N_TIME;k++)
        fprintf(fp," %7.2f",shdpri[n][i][k]);
      fprintf(fp,"\n");
    }
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");
  fclose(fp);
}

